#pragma once

#include <numeric>
#include <vector>
#include <iterator>
#include <omp.h>
#include "../pdv_lib/pdv_lib.hpp"

template<typename It>
void prefix_sum_seq(It begin, It end) {
    // Standardni knihovna umi prefixni sumu spocitat za nas.
    std::inclusive_scan(begin, end, begin);
}

template<typename It>
void prefix_sum_par(It begin, It end) {
    // type that the iterator refers to (the actual type of values in the array)
    using T = typename std::iterator_traits<It>::value_type;

    auto size = end - begin;

    #pragma omp parallel
    {
        // Rozdelte vypocet prefixni sumy pole mezi jednotliva vlakna
        // Zamyslete se, jak byste se mohli "vyhnout" zavislosti sumy
        // na prefixni sume predchazejicich prvku. (Teto zavislosti se
        // nelze vyhnout - ale mozna by nam stacilo "vysbirat" vysledky
        // ostatnich vlaken a nemuseli bychom prochazet cele pole?)
    }
    throw pdv::not_implemented();
}
